/************** The input to the process below is a dataset name test
(you can change this in the macro call command
to what ever dataset name you like). This dataset contains as variables
cika - the central index key (Text format)
accession - the accession link from the company.idx (compiled in
dataset company_idx.sas7bdat
form - the form that you want to crawl (text format)
These variables are available in the zip files from
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/companyidx_textformat.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2006.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2005.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2004.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2003.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2002.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2001.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_2000.zip
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/company_idx_sasdataset_1994to1999.z
ip
The SAS program that creates the sas datasets is the following
http://www.bschool.nus.edu.sg/staff/bizsrini/webcrawl/make_accession_ma
sterlist.sas
**********************************************************************/
/*************** Read in the dataset ***************/

data test ; set sonik ; keep name accession; 
run ;

proc print data=test;
run;

%MACRO webcrawler (ds);
/************* Code to determine the number of observations (i.e. -
websites to visit) in the input dataset. Credit SAS Institute
at:
http://ftp.sas.com/techsup/download/sample/datastep/macnumob_sas.html
********/
%global dset nvars nobs;
%let dset=&ds;
%let dsid = %sysfunc(open(&dset));
%if &dsid %then
%do;
%let nobs =%sysfunc(attrn(&dsid,nobs)); ****** nobs is macro
variable which keeps the number of observations in the dataset;
%let rc = %sysfunc(close(&dsid));
%end;
%else
%put open for data set &dset failed
%sysfunc(sysmsg());
/************* Code to determine the number of observations (i.e. -
websites to visit) in the input dataset ********/
%DO b=0 %TO &nobs-1; ****** beginning of do loop through the
observations *******;


data SiteVisitnew;
Do b=&nobs - &b;
put b;
SET &ds point=b; ****** Grab observations one at a time *******;
AccessionADD=cats("'http://www.sec.gov/Archives/", accession, "'"); ****** Specify exact website location *******;
CALL SYMPUT("SITE",AccessionADD); ****** Save website location as
a macro variable *******;
output;
end;
stop;
run;

data SiteVisitnew;
filename foo url &SITE debug;
retain linecount line countC2 name accession;
length line $256 name $63 accession $200;
infile foo lrecl=256 pad expandtabs ; ****** Accesses specified web
location and reads line by line *******;
input line $char256. ; 

linecount=_n_;
If _n_ = 1 then do;
countC2=0;
*** Variables which will be used to keep lines
surrounding our key words ****;
end; */
if line eq ' ' then return;
line1 = UPCASE(htmldecode(compress(line, ' ')));
if index(line1,'COMPANYCONFORMEDNAME:') ne 0 then do ;
name = tranwrd(line,'COMPANY CONFORMED NAME:',' ') ;
name = trim(left(name)) ;
end ;

if index(line1,'ACCESSIONNUMBER:') ne 0 then do ;
accession = tranwrd(line,'ACCESSION NUMBER:',' ') ;
accession = trim(left(accession)) ;
end ;
run;

/*data SiteVisitnew; Set SiteVisitnew; 
patternID = prxparse('/NOTIONAL/');
start = 1;
stop = length(line1);
call prxnext(patternID, start, stop, line1, position, length);
         do while (position ^= 0);
		 countC2=countC2+1;
		 do countC2=1 to 5;
            output;
			end; 
		    call prxnext(patternID, start, stop, line1, position, length);
			
			end; */
data SiteVisitnew;
Set SiteVisitnew nobs=_total_obs_;
patternID = prxparse('/NOTIONAL/');
if patternID then do j=max(1, _n_-2) to min(_total_obs_, _n_+2);
set SiteVisitnew point=j;
output;
end;
drop j;
			
PROC Append Base=Cumulate data=SiteVisitnew; 
		 run;
		 %End;
%MEND webcrawler;
%webcrawler (test);

***** Input the location of the dataset
here - the output file will be called "Cumulate" and will be in the
work library **;
***** The webcrawler assumes you have a dataset
that looks like the sample dataset with a variable called "accession"
that has the location of the SEC form - this variable is created after
running make_accession_masterlist.sas and filtering these observations
down to the forms of interest. See the test_age.sas7bdat as an example
**;
Run;
/*

